=== debian/changelog ===
castle-game-engine (7.0~alpha.1+dfsg-9) unstable; urgency=medium

  * Update Build-Depends to use libgdk-pixbuf-2.0-dev instead of
    libgdk-pixbuf2.0-dev (Closes: #1019310)
  * Fix several packaging issues (thanks lintian)

 -- Paul Gevers <elbrus@debian.org>  Thu, 08 Sep 2022 19:19:16 +0200
